# LDAP Account Manager

# lib/3rdParty/phpseclib/Net/SSH1.php

# Properties

author
category
copyright
license
link
package
version

## Description

Pure-PHP implementation of SSHv1.
PHP versions 4 and 5 Here's a short example of how to use this library: `login('username', 'password')) { exit('Login Failed'); } echo $ssh->exec('ls -la'); ?>` Here's another short example: `login('username', 'password')) { exit('Login Failed'); } echo $ssh->read('username@username:~$'); $ssh->write("ls -la\n"); echo $ssh->read('username@username:~$'); ?>` More information on the SSHv1 specification can be found by reading {@link http://www.snailbook.com/docs/protocol-1.5.txt protocol-1.5.txt}. LICENSE: Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

## Constants

### NET_SSH1_CIPHER_NONE = 0

No encryption
Not supported.

### NET_SSH1_CIPHER_IDEA = 1

IDEA in CFB mode
Not supported.

### NET_SSH1_CIPHER_DES = 2

DES in CBC mode

### NET_SSH1_CIPHER_3DES = 3

Triple-DES in CBC mode
All implementations are required to support this

### NET_SSH1_CIPHER_BROKEN_TSS = 4

TRI's Simple Stream encryption CBC
Not supported nor is it defined in the official SSH1 specs. OpenSSH, however, does define it (see cipher.h), although it doesn't use it (see cipher.c)

### NET_SSH1_CIPHER_BLOWFISH = 6

Blowfish
Not supported nor is it defined in the official SSH1 specs. OpenSSH, however, defines it (see cipher.h) and uses it (see cipher.c)

### NET_SSH1_AUTH_RHOSTS = 1

### NET_SSH1_AUTH_RSA = 2

pure RSA authentication

### NET_SSH1_AUTH_PASSWORD = 3

password authentication
This is the only method that is supported by this library.

### NET_SSH1_AUTH_RHOSTS_RSA = 4

### NET_SSH1_TTY_OP_END = 0

### NET_SSH1_RESPONSE_TYPE = 1

The Response Type

### NET_SSH1_RESPONSE_DATA = 2

The Response Data

### NET_SSH1_MASK_CONSTRUCTOR = 1

### NET_SSH1_MASK_LOGIN = 2

### NET_SSH1_MASK_SHELL = 4

### NET_SSH1_LOG_SIMPLE = 1

Returns the message numbers

### NET_SSH1_LOG_COMPLEX = 2

Returns the message content

### NET_SSH1_READ_SIMPLE = 1

Returns when a string matching $expect exactly is found

### NET_SSH1_READ_REGEX = 2

Returns when a string matching the regular expression $expect is found

### $value = $key

## Classes

### Net_SSH1

# Properties

Extends
Implements
access
public
author
Jim Wigginton
package
Net_SSH1
version
0.1.0
Abstract
No
Final
No

#### Description

Pure-PHP implementation of SSHv1.

#### Methods

Net_SSH1, __destruct, _crc, _define_array, _disconnect, _format_log, _get_binary_packet, _initShell, _rsa_crypt, _send_binary_packet, _string_shift, disconnect, exec, getHostKeyPublicExponent, getHostKeyPublicModulus, getLog, getServerIdentification, getServerKeyPublicExponent, getServerKeyPublicModulus, getSupportedAuthentications, getSupportedCiphers, interactiveRead, interactiveWrite, login, read, write,

### Net_SSH1( String $host, $port = 22, $timeout = 10, $cipher = NET_SSH1_CIPHER_3DES, ) : \Net_SSH1

#### Description

Default Constructor.
Connects to an SSHv1 server

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$host | String |  |
$port | n/a |  | 22
$timeout | n/a |  | 10
$cipher | n/a |  | NET_SSH1_CIPHER_3DES

#### Return value

Type | Description
--- | ---
\Net_SSH1 |

#### Tags

Name | Description
--- | ---
access | public

### __destruct( ) : n/a

#### Description

Destructor.
Will be called, automatically, if you're supporting just PHP5. If you're supporting PHP4, you'll need to call disconnect().

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | public

### _crc( String $data, ) : Integer

#### Description

Cyclic Redundancy Check (CRC)
PHP's crc32 function is implemented slightly differently than the one that SSH v1 uses, so we've reimplemented it. A more detailed discussion of the differences can be found after $crc_lookup_table's initialization.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$data | String |  |

#### Return value

Type | Description
--- | ---
Integer |

#### Tags

Name | Description
--- | ---
see |
see |
access | private

### _define_array( ) : n/a

#### Description

Define Array
Takes any number of arrays whose indices are integers and whose values are strings and defines a bunch of named constants from it, using the value as the name of the constant and the index as the value of the constant. If any of the constants that would be defined already exists, none of the constants will be defined.

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | private

### _disconnect( String $msg = 'Client Quit', ) : n/a

#### Description

Disconnect

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$msg | String |  | 'Client Quit'

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | private

### _format_log( Array $message_log, Array $message_number_log, ) : String

#### Description

Formats a log for printing

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$message_log | Array |  |
$message_number_log | Array |  |

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | private

### _get_binary_packet( ) : Array

#### Description

Gets Binary Packets
See 'The Binary Packet Protocol' of protocol-1.5.txt for more info. Also, this function could be improved upon by adding detection for the following exploit: http://www.securiteam.com/securitynews/5LP042K3FY.html

#### Return value

Type | Description
--- | ---
Array |

#### Tags

Name | Description
--- | ---
see |
access | private

### _initShell( ) : Boolean

#### Description

Creates an interactive shell

#### Return value

Type | Description
--- | ---
Boolean |

#### Tags

Name | Description
--- | ---
see |
see |
access | private

### _rsa_crypt( \Math_BigInteger $m, Array $key, ) : \Math_BigInteger

#### Description

RSA Encrypt
Returns mod(pow($m, $e), $n), where $n should be the product of two (large) primes $p and $q and where $e should be a number with the property that gcd($e, ($p - 1) * ($q - 1)) == 1. Could just make anything that calls this call modexp, instead, but I think this makes things clearer, maybe...

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$m | \Math_BigInteger |  |
$key | Array |  |

#### Return value

Type | Description
--- | ---
\Math_BigInteger |

#### Tags

Name | Description
--- | ---
see |
access | private

### _send_binary_packet( String $data, ) : Boolean

#### Description

Sends Binary Packets
Returns true on success, false on failure.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$data | String |  |

#### Return value

Type | Description
--- | ---
Boolean |

#### Tags

Name | Description
--- | ---
see |
access | private

### _string_shift( String $string, $index = 1, ) : String

#### Description

String Shift
Inspired by array_shift

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$string | String |  |
$index | n/a |  | 1

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | private

### disconnect( ) : n/a

#### Description

Disconnect

#### Return value

Type | Description
--- | ---
n/a | n/a

#### Tags

Name | Description
--- | ---
access | public

### exec( String $cmd, $block = true, ) : mixed

#### Description

Executes a command on a non-interactive shell, returns the output, and quits.
An SSH1 server will close the connection after a command has been executed on a non-interactive shell. SSH2 servers don't, however, this isn't an SSH2 client. The way this works, on the server, is by initiating a shell with the -s option, as discussed in the following links: {@link http://www.faqs.org/docs/bashman/bashref_65.html http://www.faqs.org/docs/bashman/bashref_65.html} {@link http://www.faqs.org/docs/bashman/bashref_62.html http://www.faqs.org/docs/bashman/bashref_62.html} To execute further commands, a new Net_SSH1 object will need to be created. Returns false on failure and the output, otherwise.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$cmd | String |  |
$block | n/a |  | true

#### Return value

Type | Description
--- | ---
mixed |

#### Tags

Name | Description
--- | ---
see |
see |
access | public

### getHostKeyPublicExponent( $raw_output = false, ) : String

#### Description

Return the host key public exponent
Returns, by default, the base-10 representation. If $raw_output is set to true, returns, instead, the raw bytes. This behavior is similar to PHP's md5() function.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$raw_output | n/a |  | false

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | public

### getHostKeyPublicModulus( $raw_output = false, ) : String

#### Description

Return the host key public modulus
Returns, by default, the base-10 representation. If $raw_output is set to true, returns, instead, the raw bytes. This behavior is similar to PHP's md5() function.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$raw_output | n/a |  | false

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | public

### getLog( ) : String

#### Description

Returns a log of the packets that have been sent and received.
Returns a string if NET_SSH2_LOGGING == NET_SSH2_LOG_COMPLEX, an array if NET_SSH2_LOGGING == NET_SSH2_LOG_SIMPLE and false if !defined('NET_SSH2_LOGGING')

#### Return value

Type | Description
--- | ---
String | or Array

#### Tags

Name | Description
--- | ---
access | public

### getServerIdentification( ) : String

#### Description

Return the server identification.

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | public

### getServerKeyPublicExponent( $raw_output = false, ) : String

#### Description

Return the server key public exponent
Returns, by default, the base-10 representation. If $raw_output is set to true, returns, instead, the raw bytes. This behavior is similar to PHP's md5() function.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$raw_output | n/a |  | false

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | public

### getServerKeyPublicModulus( $raw_output = false, ) : String

#### Description

Return the server key public modulus
Returns, by default, the base-10 representation. If $raw_output is set to true, returns, instead, the raw bytes. This behavior is similar to PHP's md5() function.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$raw_output | n/a |  | false

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
access | public

### getSupportedAuthentications( $raw_output = false, ) : Array

#### Description

Return a list of authentications supported by SSH1 server.
Just because a cipher is supported by an SSH1 server doesn't mean it's supported by this library. If $raw_output is set to true, returns, instead, an array of constants. ie. instead of array('password authentication'), you'll get array(NET_SSH1_AUTH_PASSWORD).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$raw_output | n/a |  | false

#### Return value

Type | Description
--- | ---
Array |

#### Tags

Name | Description
--- | ---
access | public

### getSupportedCiphers( $raw_output = false, ) : Array

#### Description

Return a list of ciphers supported by SSH1 server.
Just because a cipher is supported by an SSH1 server doesn't mean it's supported by this library. If $raw_output is set to true, returns, instead, an array of constants. ie. instead of array('Triple-DES in CBC mode'), you'll get array(NET_SSH1_CIPHER_3DES).

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$raw_output | n/a |  | false

#### Return value

Type | Description
--- | ---
Array |

#### Tags

Name | Description
--- | ---
access | public

### interactiveRead( ) : String

#### Description

Returns the output of an interactive shell when no more output is available.
Requires PHP 4.3.0 or later due to the use of the stream_select() function. If you see stuff like "00m", you're seeing ANSI escape codes. According to {@link http://support.microsoft.com/kb/101875 How to Enable ANSI.SYS in a Command Window}, "Windows NT does not support ANSI escape sequences in Win32 Console applications", so if you're a Windows user, there's not going to be much recourse.

#### Return value

Type | Description
--- | ---
String |

#### Tags

Name | Description
--- | ---
see |
access | public

### interactiveWrite( String $cmd, ) : Boolean

#### Description

Inputs a command into an interactive shell.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$cmd | String |  |

#### Return value

Type | Description
--- | ---
Boolean |

#### Tags

Name | Description
--- | ---
see |
access | public

### login( String $username, $password = '', ) : Boolean

#### Description

Login

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$username | String |  |
$password | n/a |  | ''

#### Return value

Type | Description
--- | ---
Boolean |

#### Tags

Name | Description
--- | ---
access | public

### read( String $expect, Integer $mode = NET_SSH1_READ_SIMPLE, ) : Boolean

#### Description

Returns the output of an interactive shell when there's a match for $expect
$expect can take the form of a string literal or, if $mode == NET_SSH1_READ_REGEX, a regular expression.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$expect | String |  |
$mode | Integer |  | NET_SSH1_READ_SIMPLE

#### Return value

Type | Description
--- | ---
Boolean |

#### Tags

Name | Description
--- | ---
see |
access | public

### write( String $cmd, ) : Boolean

#### Description

Inputs a command into an interactive shell.

#### Arguments

Name | Type | Description | Default
--- | --- | --- | ---
$cmd | String |  |

#### Return value

Type | Description
--- | ---
Boolean |

#### Tags

Name | Description
--- | ---
see |
access | public

#### Properties

$bitmap, $crypto, $fsock, $host_key_public_exponent, $host_key_public_modulus, $identifier, $interactive_buffer, $message_log, $protocol_flag_log, $protocol_flags, $server_identification, $server_key_public_exponent, $server_key_public_modulus, $supported_authentications, $supported_ciphers,

### Integer public $bitmap = 0

Execution Bitmap
The bits that are set represent functions that have been called already. This is used to determine if a requisite function has been successfully executed. If not, an error should be thrown.

### Object public $crypto = false

The cryptography object

### Object public $fsock =

The Socket Object

### String public $host_key_public_exponent =

The Host Key Public Exponent
Logged for debug purposes

### String public $host_key_public_modulus =

The Host Key Public Modulus
Logged for debug purposes

### String public $identifier = 'SSH-1.5-phpseclib'

The SSH identifier

### Array public $interactive_buffer = ''

Interactive Buffer

### Array public $message_log = array()

Message Log

### Array public $protocol_flag_log = array()

Protocol Flag Log

### Array public $protocol_flags = array()

Protocol Flags

### String public $server_identification = ''

Server Identification

### String public $server_key_public_exponent =

The Server Key Public Exponent
Logged for debug purposes

### String public $server_key_public_modulus =

The Server Key Public Modulus
Logged for debug purposes

### Array public $supported_authentications = array(NET_SSH1_AUTH_RHOSTS => '.rhosts or /etc/hosts.equiv', NET_SSH1_AUTH_RSA => 'pure RSA authentication', NET_SSH1_AUTH_PASSWORD => 'password authentication', NET_SSH1_AUTH_RHOSTS_RSA => '.rhosts with RSA host authentication')

Supported Authentications
Logged for debug purposes

### Array public $supported_ciphers = array(NET_SSH1_CIPHER_NONE => 'No encryption', NET_SSH1_CIPHER_IDEA => 'IDEA in CFB mode', NET_SSH1_CIPHER_DES => 'DES in CBC mode', NET_SSH1_CIPHER_3DES => 'Triple-DES in CBC mode', NET_SSH1_CIPHER_BROKEN_TSS => 'TRI\'s Simple Stream encryption CBC', NET_SSH1_CIPHER_RC4 => 'RC4', NET_SSH1_CIPHER_BLOWFISH => 'Blowfish')

Supported Ciphers
Logged for debug purposes
Documentation was generated by phpDocumentor 2.1.0 .

# Namespaces

- global

# Packages

- Crypt_AES
  - Crypt_AES
    Pure-PHP implementation of AES.
- Crypt_DES
  - Crypt_DES
    Pure-PHP implementation of DES.
- Crypt_Hash
  - Crypt_Hash
    Pure-PHP implementations of keyed-hash message authentication codes (HMACs) and various cryptographic hashing functions.
- Crypt_RC4
  - Crypt_RC4
    Pure-PHP implementation of RC4.
- Crypt_RSA
  - Crypt_RSA
    Pure-PHP PKCS#1 compliant implementation of RSA.
- Crypt_Random
- Crypt_Rijndael
  - Crypt_Rijndael
    Pure-PHP implementation of Rijndael.
- Crypt_TerraDES
  - Crypt_TripleDES
    Pure-PHP implementation of Triple DES.
- Crypt_TripleDES
- Help
- LDAP
  - Ldap
    Ldap manages connection to LDAP and includes several helper functions.
- Math_BigInteger
  - Math_BigInteger
    Pure-PHP arbitrary precision integer arithmetic library. Supports base-2, base-10, base-16, and base-256 numbers.
- Net_SFTP
  - Net_SFTP
    Pure-PHP implementations of SFTP.
- Net_SSH1
  - Net_SSH1
    Pure-PHP implementation of SSHv1.
- Net_SSH2
  - Net_SSH2
    Pure-PHP implementation of SSHv2.
- PDF
  - UFPDF
    Main UFPDF class for creating Unicode PDF documents
  - lamPDF
    Creates a LAM information page in PDF format.
  - xmlParser
    Simple XML parser.
- PHP_Compat
- configuration
  - LAMCfgMain
    This class manages config.cfg.
  - LAMConfig
    This class manages .conf files.
- horde.cipher
  - Horde_Cipher_blowfish
- lam
  - smbHash
    Calculates NT and LM hashes.
- lib
  - AttributeType
    Represents an LDAP AttributeType
  - MatchingRule
    Represents an LDAP MatchingRule
  - MatchingRuleUse
    Represents an LDAP schema matchingRuleUse entry
  - ObjectClass
    Represents an LDAP objectClass
  - ObjectClassAttribute
    A simple class for representing AttributeTypes used only by the ObjectClass class.
  - SchemaItem
    Generic parent class for all schema items. A schema item is an ObjectClass, an AttributeBype, a MatchingRule, or a Syntax.
  - Syntax
    Represents an LDAP Syntax
- lists
  - kolabSharedFolderTypeList
    Generates the list view.
  - lamAsteriskExtList
    Generates the list view.
  - lamBooleanListOption
    Boolean option for list configuration.
  - lamDHCPList
    Generates the list view.
  - lamGroupList
    Generates the list view.
  - lamHostList
    Generates the list view.
  - lamList
    Generates the list view.
  - lamListOption
    Represents a list configuration option.
  - lamListTool
    Represents a tool which can be included in the account lists.
  - lamMailAliasList
    Generates the list view.
  - lamNetgroupList
    Generates the list view.
  - lamPykotaBillingCodeTypeList
    Generates the list view.
  - lamPykotaPrinterTypeList
    Generates the list view.
  - lamSelectListOption
    Boolean option for list configuration.
  - lamSmbDomainList
    Generates the list view.
  - lamUserList
    Generates the list view.
- main
- metaHTML
  - htmlAccountPageButton
    Prints a button for the account pages.
  - htmlButton
    Simple button.
  - htmlDiv
    Creates a simple DIV element.
  - htmlElement
    Represents a HTML element.
  - htmlEqualHeight
    Sets all given elements to the same height.
  - htmlEqualWidth
    Sets all given elements to the same width.
  - htmlFieldset
    Generates a fieldset.
  - htmlGroup
    Groups multiple htmlElements.
  - htmlHelpLink
    Renders a help link.
  - htmlHiddenInput
    Generates a hidden input field.
  - htmlHorizontalLine
    Prints a horizontal line.
  - htmlImage
    Prints the HTML code for an image.
  - htmlInputCheckbox
    Prints the HTML code for a checkbox.
  - htmlInputField
    A standard input field.
  - htmlInputFileUpload
    Prints the HTML code for a file upload field.
  - htmlInputTextarea
    Prints the HTML code for a textarea.
  - htmlJavaScript
    Creates a JavaScript element.
  - htmlLink
    Generates a link.
  - htmlOutputText
    Prints the text and escapes contained HTML code by default.
  - htmlRadio
    Represents a radio selection.
  - htmlSelect
    Represents a select box.
  - htmlSortableList
    Creates a list of elements that can be sorted by the user via drag'n'drop.
  - htmlSpacer
    Adds an empty space with given width and height.
  - htmlStatusMessage
    Prints a status message (e.g. error message).
  - htmlSubTitle
    Generates a subtitle line. This is used to group multiple fields.
  - htmlTable
    Structures elements using a table.
  - htmlTableExtendedInputCheckbox
    Checkbox with descriptive label and help link.
  - htmlTableExtendedInputField
    An extended input field that combines label, input field and help.
  - htmlTableExtendedInputFileUpload
    File upload with descriptive label and help link.
  - htmlTableExtendedInputTextarea
    Text area with label and help link.
  - htmlTableExtendedRadio
    Radio list with descriptive label and help link.
  - htmlTableExtendedSelect
    Select with label and help link.
  - htmlTableRow
    A row inside a htmlTable.
  - htmlTitle
    Generates a title line. This is used for page titles.
- modules
  - account
    Manages the object class "account" for users and hosts.
  - accountContainer
    This class includes all modules and attributes of an account.
  - asteriskAccount
    Manages the Asterisk extension of user accounts.
  - asteriskExtension
    Manages Asterisk extensions.
  - asteriskVoicemail
    Manages the Asterisk extension of user accounts.
  - authorizedServiceObject
    Provides Authorized Service for accounts.
  - baseModule
    Parent class of all account modules.
  - ddns
    Manages DDNS entries.
  - dhcp_settings
    Manages DHCP entries.
  - eduPerson
    Manages the eduPerson extension for user accounts.
  - fixed_ip
    Manages DHCP host entries.
  - freeRadius
    Manages FreeRadius accounts.
  - generalInformation
    Shows general information like the creation time of an account.
  - hostObject
    Manages the hosts to which a user may login.
  - ieee802device
    Provides MAC addresses for hosts.
  - imapAccess
    Manages mailboxes on an IMAP server.
  - inetLocalMailRecipient
    Provides mail routing for users.
  - inetOrgPerson
    This module manages LDAP attributes of the object class inetOrgPerson (e.g. name and address).
  - kolabGroup
    Manages Kolab group accounts.
  - kolabSharedFolder
    Manages Kolab shared folders.
  - kolabUser
    Manages Kolab user accounts.
  - ldapPublicKey
    Manages SSH public keys.
  - nisMailAlias
    Provides NIS mail alias management.
  - nisnetgroup
    Manages entries based on the object class nisNetgroup.
  - passwordService
    This interface needs to be implemented by all account modules which manage passwords.
  - posixAccount
    Manages the object class "posixAccount" for users and hosts.
  - posixGroup
    Manages the object class "posixGroup" for groups.
  - puppetClient
    Manages Puppet configuration options.
  - pykotaBillingCode
    Manages PyKota billing codes.
  - pykotaGroup
    Manages PyKota group accounts.
  - pykotaGroupStructural
    Manages PyKota group accounts.
  - pykotaPrinter
    Manages PyKota printers.
  - pykotaUser
    Manages PyKota user accounts.
  - pykotaUserStructural
    Manages PyKota user accounts.
  - quota
    Manages quotas for users and groups.
  - range
    Manages DHCP ranges for DHCP server.
  - samba3domain
    Represents a Samba 3 domain entry
  - sambaDomain
    Manages Samba 3 domain entries.
  - sambaGroupMapping
    Manages the object class "sambaGroupMapping" for groups.
  - sambaMungedDial
    Manages terminal server settings for Samba 3.
  - sambaSamAccount
    Manages the object class "sambaSamAccount" for users and hosts.
  - shadowAccount
    Manages the object class "shadowAccount" for users.
  - smbHash
    Calculates NT and LM hashes.
  - systemQuotas
    Manages user quotas with the object class systemQuotas.
  - windowsGroup
    Manages Windows AD (e.g. Samba 4) groups.
  - windowsHost
    Manages Windows AD (e.g. Samba 4) hosts.
  - windowsPosixGroup
    Manages Unix groups in Windows LDAP schema.
  - windowsUser
    Manages Windows AD (e.g. Samba 4) users.
- phpLDAPadmin
- profiles
- selfService
  - selfServiceProfile
    Includes all settings of a self service profile.
- tools
  - LAMSubTool
    Represents a subtool.
  - LAMTool
    Represents a tool.
  - toolFileUpload
    File upload
  - toolMultiEdit
    Multi edit tool that allows LDAP operations on multiple entries.
  - toolOUEditor
    OU editor
  - toolPDFEditor
    PDF editor
  - toolProfileEditor
    Profile editor
  - toolSchemaBrowser
    Schema browser
  - toolServerInformation
    Server information
  - toolTests
    Tests page
- types
  - asteriskExt
    The account type for Asterisk extensions.
  - baseType
    This is the parent class of all account types.
  - dhcp
    The account type for DHCP
  - group
    The account type for group accounts (e.g. Unix and Samba).
  - host
    The account type for host accounts (e.g. Samba).
  - kolabSharedFolderType
    The account type for Kolab shared folders.
  - mailAlias
    The account type for mail aliases.
  - netgroup
    The account type for NIS netgroups.
  - pykotaBillingCodeType
    The account type for PyKota billing codes.
  - pykotaPrinterType
    The account type for PyKota printers.
  - smbDomain
    The account type for Samba domains.
  - user
    The account type for user accounts (e.g. Unix, Samba and Kolab).